#include <bits/stdc++.h>

using namespace std;

#define MAX 210000

int seg[MAX * 3][3];

int n, m, a , b, c, root = 1, q, pat[MAX];
vector <int> gr[MAX];
int st[MAX], dist[MAX], e[MAX];
vector <pair<int, int> > eu;
bool used[MAX];

void find_longest()
{
    a = b = 0;
    int node = 1;
    dist[1] = st[1];
    queue <int> q;

    q.push(node);
    while(q.size() > 0)
    {
        node = q.front();
        q.pop();
        used[node] = true;
        for(int i = 0; i < gr[node]. size(); i++)
        {
            if(used[gr[node][i]] == false)
            {
                q.push(gr[node][i]);
                dist[gr[node][i]] = dist[node] + st[gr[node][i]];
            }
        }
    }

    for(int i = 1; i <= n; i++)if(dist[a] < dist[i])a = i;
    for(int i = 1; i <= n; i++)used[i] = false;
    for(int i = 1; i <= n; i++)dist[i] = 0;

    node = a;
    dist[a] = st[a];
    q.push(node);
    while(q.size() > 0)
    {
        node = q.front();
        q.pop();
        used[node] = true;
        for(int i = 0; i < gr[node]. size(); i++)
        {
            if(used[gr[node][i]] == false)
            {
                q.push(gr[node][i]);
                dist[gr[node][i]] = dist[node] + st[gr[node][i]];
            }
        }
    }
    for(int i = 1; i <= n; i++)if(dist[b] < dist[i])b = i;
}
// a i b - kraishta na longest path

void dfs(int node, int d)
{
/*
    if(e[node] == -1)e[node] = eu.size();
    eu.push_back(make_pair(node, d));
    used[node ] = true;
    for(int i = 0; i < gr[node].size(); i++)
    {
        if(used[gr[node][i]] == false)
        {
            dfs(gr[node][i], d+ 1);
            eu.push_back(make_pair(node, d));
        }
    }
*/
}

void build(int v, int l, int r)
{
    if(l == r)
    {
        seg[v][0] = eu[l].first;
        seg[v][1] = eu[l].second;
        return;
    }
    int mid = (l + r) / 2;
    build(v * 2, l, mid);
    build(v * 2 + 1, mid + 1, r);
    if(seg[v * 2][1] > seg[v * 2 + 1][1])
    {
        seg[v][0] = seg[v * 2 + 1][0];
        seg[v][1] = seg[v * 2 + 1][1];
    }
    else
    {
        seg[v][0] = seg[v * 2 ][0];
        seg[v][1] = seg[v * 2 ][1];
    }
}

pair<int, int> query(int v, int l, int r, int ql, int qr)
{

    if(ql <= l && qr >= r)return make_pair(seg[v][0], seg[v][1]);
    if(ql > r || qr < l)return make_pair(12345678, 12345678);
    int mid = (l + r) / 2;
    pair<int, int> r1 = query(v * 2, l, mid, ql, qr);
    pair<int, int> r2 = query(v * 2 + 1, mid + 1, r, ql, qr);
    if(r1.second > r2.second)return r2;
    return r1;
}

void lca()
{
    for(int i = 1; i <= n; i++)used[i] = false, e[i] = -1;
    dfs(root, 0);
    int stl = eu.size();
    build(1, 0, stl - 1);
}

void pas(int node)
{
    for(int i = 1; i <= n; i++)used[i] = false;
    queue <int> q;
    pat[node] = st[node];
    q.push(node);
    while(q.size() > 0)
    {
        node = q.front();
        q.pop();
        used[node] = true;
        for(int i = 0; i < gr[node]. size(); i++)
        {
            if(used[gr[node][i]] == false)
            {
                q.push(gr[node][i]);
                pat[gr[node][i]] = pat[node] + st[gr[node][i]];
            }
        }
    }

}

int quer(int node)
{
    int l = e[node], r = e[a];
    if(l > r)swap(l, r);
    int ko = query(1, 0, eu.size() - 1, l, r).first;

    int temp = pat[node] + pat[a] - 2 * pat[ko] + st[ko] - st[node], ans = 0;

    //if(ko == node)temp += st[node];

    ans = max(ans, temp);
    r = e[b];
    if(l > r)swap(l, r);
    ko = query(1, 0, eu.size() - 1, l, r).first;
    temp = pat[node] + pat[b] - 2 * pat[ko] + st[ko] - st[node];
    //if(ko == node)temp += st[node];
    ans = max(ans, temp);
    return ans;
}

int main()
{
    cin >> n;
    for(int i = 0; i < n - 1; i++)
    {
        cin >> a >> b;
        gr[a].push_back(b);
        gr[b].push_back(a);
    }
    cin >> m;
    for(int i = 0; i < m; i++)
    {
        cin >> a >> b;
        st[a] = b;
    }
    find_longest();
    lca();
    pas(1);
    cin >> q;
    queue<int>ans1;
    for(int i = 0; i < q; i++)
    {
        cin >> c;
        cout << quer(c) << " " ;
    }

    return 0;
}
/*

9
3 6
3 4
6 1
1 7
4 2
4 5
2 8
2 9
5
3 3
2 1
5 2
9 4
7 3
3
3 2 8


*/
