#include <bits/stdc++.h>

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl
#define sz(x) ((int)x.size())
#define all(x) x.begin(), x.end()

using namespace std;
template<class T, class T1> inline bool chkmax(T &x, const T1 &y) { return x < y ? x = y, true : false; }
template<class T, class T1> inline bool chkmin(T &x, const T1 &y) { return x > y ? x = y, true : false; }

const int MAXN = 200001;

int n;
vector<int> g[MAXN];
int k[MAXN];
long long dp[MAXN];

long long bfs(int start) {
    long long ans = 0;
    memset(dp, 0, sizeof(dp));
    queue<pair<int, int>> q;
    q.emplace(start, -1);
    while (!q.empty()) {
        pair<int, int> now = q.front();
        q.pop();
        for (int adj : g[now.first]) {
            if (adj != now.second) {
                dp[adj] = dp[now.first] + k[adj];
                q.emplace(adj, now.first);
            }
        }
    }
    for (int i = 1; i <= n; i++) chkmax(ans, dp[i]);
    return ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n;
    for (int i = 1; i < n; i++) {
        int u, v;
        cin >> u >> v;
        g[u].emplace_back(v);
        g[v].emplace_back(u);
    }
    memset(k, 0, sizeof(k));
    int m;
    cin >> m;
    for (int i = 1; i <= m; i++) {
        int node, k;
        cin >> node >> k;
        ::k[node] = k;
    }
    int t;
    cin >> t;
    for (int i = 1; i <= t; i++) {
        int s;
        cin >> s;
        cout << bfs(s) << " \n"[i == t];
    }

    return EXIT_SUCCESS;
}


/**
9
3 6
3 4
6 1
1 7
4 2
4 5
2 8
2 9
5
3 3
2 1
5 2
9 4
7 3
3
3 2 8
*/
