#include<iostream>
#include<vector>
#include<algorithm>
using namespace std;

bool obhoden[200001];
bool isListo[200001];
int vals[200001];
int valsFromOrigin[200001];

int n, m, k;

vector<vector<int> > graph;

void init(int cur, int val)
{
    if (isListo[cur] == true) valsFromOrigin[cur] = val + vals[cur];
    obhoden[cur] = true;
    for (int i=0; i<graph[cur].size(); i++)
    {
        if (obhoden[ graph[cur][i] ] == false)
        {
            init(graph[cur][i], val + vals[cur]);
        }
    }
}

int main ()
{
    cin>>n;
    graph.resize(n+1);
    for (int i=0; i<n-1; i++)
    {
        int a, b;
        cin>>a>>b;
        graph[a].push_back(b);
        graph[b].push_back(a);
    }
    for (int i=1; i<=n; i++) if (graph[i].size() == 1) isListo[i] = true;
    cin>>m;
    for (int i=0; i<m; i++)
    {
        int a, b;
        cin>>a>>b;
        vals[a] = b;
    }
    cin>>k;
    for (int i=0; i<k; i++)
    {
        int a;
        cin>>a;

        init(a, -vals[a]);

        for (int i=1; i<=n; i++) obhoden[i] = false;
        sort(valsFromOrigin+1, valsFromOrigin + n + 1);
        cout<<valsFromOrigin[n]<<" ";
    }
    cout<<endl;
    return 0;
}
/**
9
3 6
3 4
6 1
1 7
4 2
4 5
2 8
2 9
5
3 3
2 1
5 2
9 4
7 3
3
3 2 8
*/
