#include<iostream>
using namespace std;
long long sng[7][7]= {{1,0,0,0,0,0,0},{1,1,0,0,0,0,0},{1,0,1,0,0,0,0},{0,1,0,2,0,0,0},{0,0,1,0,2,0,0},{0,1,1,0,0,2,0},{0,0,0,0,0,1,1}};
long long m;
struct mat
{
    long long val[7][7];//={{1,0,0,0,0,0,0},{1,1,0,0,0,0,0},{1,0,1,0,0,0,0},{0,1,0,2,0,0,0},{0,0,1,0,2,0,0},{0,1,1,0,0,2,0},{0,0,0,0,0,1,1}};
    void build()
    {
        for(long long i=0; i<7; i++)
        {
            for(long long j=0; j<7; j++)
            {
                this->val[i][j]=sng[i][j];
            }
        }
    }
};
mat mult(mat a,mat b)
{
    mat ans;
    for(long long i=0; i<7; i++)
    {
        for(long long j=0; j<7; j++)
        {
            ans.val[i][j]=0;
            for(long long k=0; k<7; k++)
            {
                ans.val[i][j]+=a.val[i][k]*b.val[k][j];
                ans.val[i][j]%=m;
            }
        }
    }
    return ans;
}
mat f_pow(mat a,long long b){
    if(b==1){
        return a;
    }
    mat curr=f_pow(a,b/2);
    if(b%2==0){
        return mult(curr,curr);
    }else{
        return mult(mult(curr,curr),a);
    }
}
//long long mat[7][7]={{1,0,0,0,0,0,0},{1,1,0,0,0,0,0},{1,0,1,0,0,0,0},{0,1,0,2,0,0,0},{0,0,1,0,2,0,0},{0,1,1,0,0,2,0},{0,0,0,0,0,1,1}};
int main()
{
    long long n;
    cin>>n>>m;
    mat def,ans;
    def.build();
    ans.build();
    for(long long i=1; i<n; i++)
    {
        ans=mult(ans,def);
    }
    /*for(long long i=0; i<7; i++)
    {
        for(long long j=0; j<7; j++)
        {
            cout<<ans.val[i][j]<<" ";
        }
        cout<<endl;
    }*/
    long long nans=0;
    for(long long i=0;i<7;i++){
        nans+=ans.val[i][0];
        nans%=m;
    }
    cout<<nans<<endl;
    return 0;
}
