#include <iostream>
#include <map>
#include <set>

#define MAX_K 200001

std::set<int> gm[MAX_K];
//std::vector<std::vector<int>> gm;

int d[MAX_K];
int w[MAX_K];
bool used[MAX_K];

int main()
{
    int n;
    std::cin >> n;

    n++;

    /*gm.resize(n);
    for(int i = 0; i < n; i++)
    {
        gm[i].resize(n);
        std::fill(gm[i].begin(), gm[i].end(), -1);
    }*/

    int p, q;
    for(int i = 2; i < n; i++)
    {
        std::cin >> p >> q;

        gm[p].insert(q);
        gm[q].insert(p);
    }

    int m;
    std::cin >> m;

    int g, k;
    for(int i = 0; i < m; i++)
    {
        std::cin >> g >> k;
        w[g] = k;
        /*for(int i = 1; i < n; i++)
            if(gm[i][g] != -1)
                gm[i][g] = k;*/
    }

    int t;
    std::cin >> t;

    int a;
    while(t--)
    {
        std::cin >> a;

        /*for(int i = 1; i < n; i++)
            for(int j = 1; j < n; j++)
                if(gm[i][j] == -1)
                    gm[i][j] = MAX_K;*/

        for(int i = 1; i < n; i++)
        {
            used[i] = true;
            d[i] = gm[a].count(i) > 0 ? w[i] : MAX_K;
        }

        used[a] = false;

        while(true)
        {
            int j = -1;
            int ds = MAX_K;

            for(int i = 1; i < n; i++)
            {
                if(used[i] && d[i] < ds)
                {
                    ds = d[i];
                    j = i;
                }
            }

            if(j == -1)
                break;

            used[j] = false;

            for(int i = 1; i < n; i++)
                if(d[i] > d[j] + w[i] && gm[i].count(j) > 0)
                    d[i] = d[j] + w[i];
        }

        int max_d = -1;
        for(int i = 1; i < n; i++) {
            if(d[i] > max_d)
                max_d = d[i];
        }

        std::cout << max_d << " ";
    }

    std::cout << "\n";

    return 0;
}
