#include <iostream>
#include <map>
#include <unordered_set>

#define MAX_K 200001

std::unordered_set<int> gm[MAX_K];

int d[MAX_K];
int w[MAX_K];
bool used[MAX_K];

int main()
{
    int n;
    std::cin >> n;

    n++;

    int p, q;
    for(int i = 2; i < n; i++)
    {
        std::cin >> p >> q;

        gm[p].insert(q);
        gm[q].insert(p);
    }

    int m;
    std::cin >> m;

    int g, k;
    for(int i = 0; i < m; i++)
    {
        std::cin >> g >> k;
        w[g] = k;
    }

    int t;
    std::cin >> t;

    int a;
    while(t--)
    {
        std::cin >> a;
        int max_d = -1;

        for(int i = 1; i < n; i++)
        {
            used[i] = true;
            d[i] = gm[a].count(i) > 0 ? w[i] : MAX_K;
        }

        used[a] = false;

        while(true)
        {
            int j = -1;
            int ds = MAX_K;

            for(int i = 1; i < n; i++)
                if(used[i] && d[i] < ds)
                {
                    ds = d[i];
                    j = i;
                }

            if(j == -1)
                break;

            used[j] = false;

            for(int i = 1; i < n; i++)
                if(d[i] > d[j] + w[i] && gm[i].count(j) > 0)
                {
                    d[i] = d[j] + w[i];
                    if(max_d < d[i])
                        max_d = d[i];
                }
        }

        std::cout << max_d << " ";
    }

    std::cout << "\n";

    return 0;
}
