#include"corridor.h"

/**
0 - init set
1 - if a loop smaller than 23
2 - indicate next step to be move (0 - don't move; 1 - move left; 2 - move right)


4 - current phase

phase 0 -> set init values
phase 1 -> set bits
phase 2 -> check for under 23
phase 103 -> loop around till you find the magic number
phase 203 -> something else

Magic number - 4527488

2^23 = 8388608
*/

step solve(char cellValue)
{
    step ret;
    if (get_memory(2) == 1)
    {
        ret.action = 'l';
        set_memory(2, 0);
        return ret;
    }
    else if (get_memory(2) == 2)
    {
        ret.action = 'r';
        set_memory(2, 0);
        return ret;
    }

    int phase = get_memory(4);

    if (phase == 0)
    {
        set_memory(4, 1);
        set_memory(0, 2263744);
        if (cellValue == '1')
        {
            set_memory(2, 1);
            ret.action = 't';
        }
        else
        {
            ret.action = 'l';
        }
        return ret;
    }
    else if (phase == 1)
    {
        int cur = get_memory(0);
        if (cur%2 != cellValue - '0')
        {
            set_memory(2, 1);
            ret.action = 't';
        }
        else
        {
            ret.action = 'l';
        }
        if (cur/2 != 0) set_memory(0, cur/2);
        else
        {
            set_memory(0, 0);
            set_memory(2, 2);
            set_memory(4, 2);
        }
        return ret;
    }
    else if (phase == 2)
    {
        int stepsDone = get_memory(1);
        if (stepsDone < 23)
        {
            int getCurrent = get_memory(0);
            getCurrent = getCurrent*2 + cellValue - '0';
            stepsDone++;
            set_memory(0, getCurrent);
            set_memory(1, stepsDone);
            ret.action = 'r';
            return ret;
        }
        else
        {
            if (get_memory(0) == 4527488)
            {
                set_memory(4, 103);
            }
            else
            {
                set_memory(4, 203);
            }

            if (cellValue == '0')
            {
                ret.action = 't';
            }
            else
            {
                ret.action = 'l';
                set_memory(2, 2);
            }
            set_memory(0, 0);
            return ret;
        }
        return ret;
    }
    else if (phase = 103)
    {
        int ans = get_memory(3) + 1;
        set_memory(3, ans);

        if (ans <= 23)
        {
            ret.action = 'r';
            set_memory(0, get_memory(0)*2 + cellValue - '0');
        }
        else
        {
            int cur = get_memory(0);
            if (cur > 8388608) cur -= 8388608;
            cur = cur*2 + cellValue - '0';
            set_memory(0, cur);
            if (cur == 4527488)
            {
                ret.action = 'a';
                ret.answer = ans;
            }
            else ret.action = 'r';
        }
        return ret;
    }
}
/// 10001010101010100010100100100100101001111110101010010101
