#include<iostream>
#include<vector>
#include<queue>
#include<math.h>
#include<algorithm>
#define endl '\n'

using namespace std;

const int MAXN = 200000;

int n, m, t;

struct point
{
    vector<int> con;
    int pr;
    int max_pr;
};
point p[MAXN+100];

int tests[MAXN+100];

void input()
{
    int a, b;

    cin>>n;
    for (int i=0; i<n-1; i++)
    {
        cin>>a>>b;
        p[a].con.push_back(b);
        p[b].con.push_back(a);
    }//cerr<<"END N\n";

    cin>>m;
    for (int i=0; i<m; i++)
    {
        cin>>a>>b;
        p[a].pr = b;
    }//cerr<<"END M\n";

    cin>>t;
    for (int i=0; i<t; i++)
    {
        cin>>tests[i];
    }//cerr<<"END T\n";
}

void output()
{

}

int dfs(int curr, int past)
{
    int mx=0, temp;
    for (int i=0; i<p[curr].con.size(); i++)
    {
        if (p[curr].con[i]!=past)
        {
            temp = dfs(p[curr].con[i], curr);
            mx = max (temp, mx);
        }
    }
    //cerr<<curr<<' '<<mx<<endl;
    if (past==-1) return mx;
    else return p[curr].pr+mx;
}

int find_childless()
{
    for (int i=0; i<n; i++)
    {
        if (p[i].con.size()==1) return i;
    }
}

void solve()
{
    int beg;
    //beg = find_childless();
    for (int i=0; i<t; i++)
    {
        cout<<dfs(tests[i], -1)<<' ';
        //cerr<<endl;
    }
    cout<<endl;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    input();
    solve();
    output();
    return 0;
}

/*
9
3 6
3 4
6 1
1 7
4 2
4 5
2 8
2 9
5
3 3
2 1
5 2
9 4
7 3
3
3 2 8

*/

