#include<iostream>
#include<vector>
#include<queue>
#include<math.h>
#include<algorithm>
#define endl '\n'

using namespace std;

const int MAXN = 200000;

int n, m, t;

struct point
{
    vector<int> con;
    int parent;
    int price;
    int max1, from;
    int max2;
};
point p[MAXN+100];

int tc=0, ts[MAXN+10];

int tests[MAXN+100];

void input()
{
    int a, b;

    cin>>n;
    for (int i=0; i<n-1; i++)
    {
        cin>>a>>b;
        a--;b--;
        p[a].con.push_back(b);
        p[b].con.push_back(a);
    }//cerr<<"END N\n";

    cin>>m;
    for (int i=0; i<m; i++)
    {
        cin>>a>>b;
        a--;
        p[a].price = b;
    }//cerr<<"END M\n";

    cin>>t;
    for (int i=0; i<t; i++)
    {
        cin>>tests[i];
        tests[i]--;
    }//cerr<<"END T\n";
}

void output()
{
    for (int i=0; i<t; i++)
    {
        cout<<p[tests[i]].max1<<' ';
    }
    cout<<endl;
}

int dfs_ts(int curr, int past)
{
    ts[tc++] = curr;
    p[curr].parent = past;
    int mx=0, temp;
    for (int i=0; i<p[curr].con.size(); i++)
    {
        if (p[curr].con[i]!=past)
        {
            temp = dfs_ts(p[curr].con[i], curr);
            if (p[curr].max1<temp)
            {
                p[curr].max2 = p[curr].max1;
                p[curr].max1 = temp;
                p[curr].from = p[curr].con[i];
            }
            else
            {
                if (p[curr].max2<temp)
                {
                    p[curr].max2 = temp;
                }
            }
        }
    }


    return p[curr].max1 + p[curr].price;
}

void CalculateFirstMax()
{
    int t, par, temp;
    for (int i=tc-1; i>0; i--)
    {
        t = ts[i];
        par = p[t].parent;
        temp = p[t].max1 + p[t].price;
        if (p[par].max1<temp)
        {
            p[par].max2 = p[par].max1;
            p[par].max1 = temp;
            p[par].from = t;
        }
        else
        {
            if (p[par].max2<temp)
            {
                p[par].max2 = temp;
            }
        }
    }
}

void CalculateFinalMax()
{
    int t, par, temp;
    for (int i=1; i<tc; i++)
    {
        t = ts[i];
        par = p[t].parent;
        if (p[par].from == t)
        {
            temp = p[par].max2 + p[par].price;
        }
        else
        {
            temp = p[par].max1 + p[par].price;
        }
        if (p[t].max1<temp)
        {
            p[t].max2 = p[t].max1;
            p[t].max1 = temp;
            p[t].from = par;
        }
        else
        {
            if (p[t].max2<temp)
            {
                p[t].max2 = temp;
            }
        }
    }
}

void solve()
{
    dfs_ts(0, -1);
    /*for (int i=tc-1; i>0; i--)
    {
        cerr<<ts[i]+1<<' ';
    }cerr<<endl;*/
    //CalculateFirstMax();
    /*for (int i=0; i<n; i++)
    {
        cerr<<p[i].max1<<' ';
    }*/
    CalculateFinalMax();
    /*for (int i=0; i<n; i++)
    {
        cerr<<p[i].max1<<' ';
    }*/
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    input();
    solve();
    output();
    return 0;
}

/*
9
3 6
3 4
6 1
1 7
4 2
4 5
2 8
2 9
5
3 3
2 1
5 2
9 4
7 3
3
3 2 8

*/


