#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 200003
using namespace std;
mt19937 randGenerator(123);
typedef long long ll;
int n, t, m;
int k[MAXN];
int best[MAXN];
vector <int> adj[MAXN];
vector <int> test;
bool used[MAXN];

void input()
{
    cin >> n;
    for (int i = 0; i < n - 1; ++i)
    {
        int x, y;
        cin >> x >> y;
        adj[x].push_back(y);
        adj[y].push_back(x);
    }
    memset(k, 0, sizeof(k));
    cin >> m;
    for (int i = 0; i < m; ++i)
    {
        int x, y;
        cin >> x >> y;
        //cout << "** " << x << " " << y << endl;
        k[x] = y;
    }
    cin >> t;
    for (int i = 0; i < t; ++i)
    {
        int x;
        cin >> x;
        test.push_back(x);
    }
}

void dfs(int tmp, int sum, int par = -1)
{
    int cnt = 0;
    //cout << tmp << " - " << sum << endl;
    best[tmp] = max(best[tmp], sum);
    for (int i = 0; i < adj[tmp].size(); ++i)
        if (adj[tmp][i] != par)
            ++cnt;
    for (int i = 0; i < adj[tmp].size(); ++i)
        if (adj[tmp][i] != par)
            dfs(adj[tmp][i], sum + k[tmp], tmp);
    if (cnt == 1)
        used[tmp] = 1;
}

void solve()
{
    for (int i = 1; i <= n; ++i)
        if (adj[i].size() == 1)
        {
            //cout << "----" << endl;
            //cout << i << ": " << endl;
            dfs(i, 0);
        }
    for (int i = 1; i <= n; ++i)
        if (!used[i])
        {
            //cout << "----" << endl;
            //cout << i << ": " << endl;
            dfs(i, 0);
        }
    cout << best[test[0]];
    for (int i = 1; i < t; ++i)
        cout << " " << best[test[i]];
    cout << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    input();
    solve();

    return 0;
}

/**
9
3 6
3 4
6 1
1 7
4 2
4 5
2 8
2 9
5
3 3
2 1
5 2
9 4
7 3
3
3 2 8

5 6 7
**/
