#include <iostream>

using namespace std;

long long pow2 (int n, int m)
{
	if (n == 0) return 1;
	if (n == 1) return 2;
	long long a = pow2 (n / 2, m);
	if (n % 2 == 0)
	{
		return (a * a) % m;
	}
	else
	{
		return (((a * a) % m) * 2) % m;
	}
}

int main () 
{
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	long long n, m;
	cin >> n >> m;
	long long sum = (pow2 (n, m) * 3 - 3) % m;
	long long end_point = n - 2;
	for (int i = 1 ; i <= end_point ; i ++)
	{
		sum += (i + 1) * (pow2 (n - i, m) - 2);
		sum %= m;
		if (n == 1)
			sum += n / i, end_point = (n % i), i = 1;
		if (n == 0)
			end_point = (n % i), i = 1;
	}
	cout << sum << endl;
}

